#include "stdafx.h"
#include <windows.h>
#include "MemCal.h"


VOID InitMem()
{
	BYTE    Status = 0;

    Status=LoadATSZIoDriver();
 	if(!Status){
		printf("ATSZ driver load fail.\n");
	}
}

VOID ReleaseMem()
{
   CloseATSZIoDriver();
}

DWORD MapMem_wcsrch( DWORD SourceAddrPhy, DWORD dwSourceSize, char* pSig )	// return sig offset of SourceAddr
{
	DWORD	dwIndex, dwSrcIndex;	
	DWORD	dwSiglength = strlen(pSig);
	DWORD	dwFinal = dwSourceSize - dwSiglength;
	BYTE    Status = 0;

	PVOID       pPhysMemLin,*ppPhysMemLin;
    HANDLE      handle;
    ppPhysMemLin = &pPhysMemLin;

    Status = Get_MemLin(SourceAddrPhy, dwSourceSize, ppPhysMemLin, &handle);
	if(!Status){
		printf("Get_MemLin Failed\n");
	}

	for( dwSrcIndex=0; dwSrcIndex <= dwFinal; dwSrcIndex++ )
	{
		dwIndex = 0;
		while ( ((PBYTE)pPhysMemLin)[dwSrcIndex + dwIndex] == (BYTE)pSig[dwIndex] )
		{
			dwIndex++;
			if( dwIndex >= dwSiglength )
			{
				Free_MemLin(*ppPhysMemLin,handle);
				return	dwSrcIndex;
			}
		}			
	}

	Free_MemLin(*ppPhysMemLin,handle);
	return -1;
}