#include "stdafx.h"
#include <windows.h>
#include "WmiBufferCal.h"

UINT32 GetWmiBufferAddr(UINT32 DSDTTableAddr)
{
  DWORD       WmiBufferOffset = 0, WmiBufferAddr = 0;
  PDWORD      pWmiBufferAddr;


  WmiBufferOffset = MapMem_wcsrch( DSDTTableAddr, 0x200000, "RAMA" );
  if( WmiBufferOffset != -1 )
  {
			pWmiBufferAddr = (&WmiBufferAddr);
            Read_Mem_Dword(WmiBufferOffset + DSDTTableAddr + 0x05,pWmiBufferAddr);

			//printf("WmiBufferAddr = %08x\n", *pWmiBufferAddr);
			return (*pWmiBufferAddr);
  }
  else   printf("WmiBufferOffset NotFound\n");

}
 
VOID GetLastError(IN UINT32 WmiBufferAddr)
{
	 WMI_RMT_BUFF WmiBufferDataTemp;

     WmiBufferDataTemp.Status = 0x00000000;
	 Read_Mem_Dword(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,Status), &WmiBufferDataTemp.Status);
	 printf("\n  Output:\n\n ");
	 //printf("\n Output:\n\n");
	 printf("    Last ErrorCode = %08x\n",WmiBufferDataTemp.Status);
}

VOID SetAndGetWmiBufferWithFormat(IN UINT32 WmiBufferAddr, IN INPUT_BUFF_FORMAT InputFormat, OUT WMI_RMT_BUFF* WmiBufferData)
{

  PBYTE   bData;
  BYTE    Data=0xDA;
  BYTE    Index = 0, IndexHead = 0, IndexTail = 0;
  WMI_RMT_BUFF WmiBufferDataTemp;//using this temp to cal struct offset

  //Init
  WmiBufferData->Status = 0x00000000;

  Write_Mem_Dword(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,Func), WmiBufferData->Func);
  Write_Mem_Dword(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,Status), WmiBufferData->Status);
  

  /*
  for (BYTE Count = 0; Count < InputFormat.DataCount ; Count++)
  {
	  if(InputFormat.FormatBuff[Count] == UnicodeString)
	  {
         IndexTail = WmiBufferData->InputData[IndexHead];
         for( Index = IndexHead; Index < IndexHead + IndexTail + UnicodeStringOffset; Index++) //Write Inputdata to Buffer
         {
	        Write_Mem_Byte(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,InputData[Index]), WmiBufferData->InputData[Index]);
	        //printf("%d: %d,%02x\n",Count,Index,WmiBufferData->InputData[Index]);
         }
	     IndexHead = IndexHead + IndexTail + UnicodeStringOffset;
	  }
	  else if(InputFormat.FormatBuff[Count]>=1 && InputFormat.FormatBuff[Count]<=8) //InputFormat.FormatBuff[Count] in {HexUint8=1,HexUint16=2,HexUint32=4,HexUint64=8}
	  {
		  for(int i=0; i<InputFormat.FormatBuff[Count]; i++)
		  {
		    Write_Mem_Byte(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,InputData[IndexHead + i]), WmiBufferData->InputData[IndexHead + i]);
		    printf("MemWrite(%02x,%02x)\n",Cal_OFFSET(WmiBufferDataTemp,InputData[IndexHead + i]),WmiBufferData->InputData[IndexHead + i]);
		  }
		  IndexHead = IndexHead + InputFormat.FormatBuff[Count];
		  IndexTail = IndexHead;
	  }
  }

  for( Index = IndexHead; Index < 0x70; Index++) //Set 0 to the rest of Inputdata Buffer
  {
	  Write_Mem_Byte(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,InputData[Index]), 0);
  }
  */
  for( Index = 0; Index < 0x70; Index++) //Set 0 to the rest of Inputdata Buffer
  {
	  Write_Mem_Byte(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,InputData[Index]), WmiBufferData->InputData[Index]);
  }
  for( Index = 0; Index < 0x80 ; Index++) //Set 0 to Outputdata[0x80]
  {
	  Write_Mem_Byte(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,OutputData[Index]), 0);
  }

  //SwSMI
  bData=(&Data);
  Write_Io_Byte(0xB2,bData);

  //Out
  Read_Mem_Dword(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,Status), &WmiBufferData->Status);
  if( WmiBufferData->Status == 0)
  {
	  printf("\n  Status  = Successful.\n");
	  for( Index = 0; Index < 0x80 ; Index++) //Read Outputdata[0x80]
      {
	    Read_Mem_Byte(WmiBufferAddr + Cal_OFFSET(WmiBufferDataTemp,OutputData[Index]),  &WmiBufferData->OutputData[Index]);
      }
  }
  else
  {
	  printf("\n  Status  = %08x. Failed.\n",WmiBufferData->Status);
  }
}

