#include "BasicLib.h"
#include "MemCal.h" //using Read_Mem_Dword();


#define     ACPIBASE      0xE0000
#define     MAX_TABLE_NUM 256

typedef	struct {
	BYTE	signature[8];
	BYTE	checksum;
	BYTE	oemid[6];
	BYTE	revision;
	DWORD	address;
} RSDT_PTR;

typedef	struct {
	BYTE	signature[4];
	DWORD	length;
	BYTE	revision;
	BYTE	checksum;
	BYTE	oemid[6];
	BYTE	oemtableid[8];
	DWORD	oemrevision;
	DWORD	createrid;
	DWORD	createrrevision;
} DSCPT_HEADER;

typedef	struct {
	DSCPT_HEADER    header;
	DWORD    entry[MAX_TABLE_NUM];
}RSDT_Table;

typedef struct {
	DSCPT_HEADER	header;
	DWORD	FIRMWARE_CTRL;
	DWORD	DSDT;
	//......
} FACP_Table;


UINT32 GetACPITable();

UINT32 GetRSDTTable(UINT32 ACPITableAddr);

UINT32 GetFACPTable(UINT32 RSDTTableAddr);

UINT32 GetDSDTTable(UINT32 FACPTableAddr);
