#define     Cal_OFFSET(struc,member) (char *)&struc.member-(char *)&struc
#define     UnicodeStringOffset 2
#define InDataCount 2
#define OutDataCount 1

typedef struct _LSA_UNICODE_STRING{
        UINT8  Length;
		UINT8  MaximumLength;
		UINT16 Buffer[1];
}UNICODE_STRING;


enum FORMATLIST
{
	UnicodeString,
	WordHex,
	String,
	NotSure,
	Undefined
};
typedef struct _INPUT_BUFF_FORMAT{
	    int   DataCount;
        FORMATLIST FormatBuff[InDataCount];
 }INPUT_BUFF_FORMAT;

typedef struct _OUTPUT_BUFF_FORMAT{
	    int   DataCount;
        FORMATLIST FormatBuff[OutDataCount];
 }OUTPUT_BUFF_FORMAT;



VOID StringToLower(IN char *String,OUT char *OutString);

VOID UnicodeStringToString(IN BYTE *UnicodeInputData, OUT char *String);
VOID StringToUnicodeStringWithOffset(IN char *String, IN BYTE InputDataOffset, OUT BYTE *UnicodeInputData);
VOID StringToHexByteWithOffset(IN char *String, IN BYTE ConvertStart, OUT BYTE *HexData);

VOID StringConvert(IN char StringBuff[][0x70], IN INPUT_BUFF_FORMAT InputFormat, OUT BYTE *ConvertData);

